/*
  Some examples with pointers


*/

#include <iostream>
#include <iomanip>

using namespace std ;

int
main() {
  
  short int vec[] = {1,2,3,4,5,6} ;
  
  cout << "Print the vector:\n" ;
  for ( int i = 0 ; i < 6 ; ++i )
    cout << "vec[" << i << "] = " << vec[i] << '\n' ;

  short int * pvec ; // pointer to an integer
  
  pvec = & vec[3] ; // pvec now "point" to the 4th element of the vector
  cout << "vec[3] = " << vec[3] << '\n' ;
  cout << "*pvec  = " << *pvec << '\n' ;
  
  cout << "modify *pvec = 123\n" ;
  *pvec = 123 ;

  cout << "Print the vector:\n" ;
  for ( int i = 0 ; i < 6 ; ++i )
    cout << "vec[" << i << "] = " << vec[i] << '\n' ;
  
  cout << "Loop using pointer pvec...\n" ;
  int i ;
  for ( i = 0, pvec = vec ; i < 6 ; ++i, ++pvec )
    *pvec = 2 ;

  cout << "Print the vector:\n" ;
  for ( int i = 0 ; i < 6 ; ++i )
    cout << "vec[" << i << "] = " << vec[i] << '\n' ;

  cout << "Better Loop using pointer pvec...\n" ;
  for ( pvec = vec ; pvec < vec+6 ; ++pvec )
    { cout << "Modify at address: " << pvec 
           << " the value " << *pvec << '\n' ;
      *pvec = 3 ; }

  cout << "Print the vector:\n" ;
  for ( int i = 0 ; i < 6 ; ++i )
    cout << "vec[" << i << "] = " << vec[i] << '\n' ;


  return 0 ;
}
