/*--------------------------------------------------------------------------*\
 |                                                                          |
 |  Copyright (C) 2014                                                      |
 |                                                                          |
 |         , __                 , __                                        |
 |        /|/  \               /|/  \                                       |
 |         | __/ _   ,_         | __/ _   ,_                                | 
 |         |   \|/  /  |  |   | |   \|/  /  |  |   |                        |
 |         |(__/|__/   |_/ \_/|/|(__/|__/   |_/ \_/|/                       |
 |                           /|                   /|                        |
 |                           \|                   \|                        |
 |                                                                          |
 |      Enrico Bertolazzi                                                   |
 |      Dipartimento di Ingegneria Indutriale                               |
 |      Universita` degli Studi di Trento                                   |
 |      Via Sommarive 9, I-38123, Povo, Trento                              |
 |      email: enrico.bertolazzi@unitn.it                                   |
 |                                                                          |
 |      version: 0.1                                                        |
 |                                                                          |
\*--------------------------------------------------------------------------*/

// to avoid double inclusion
#ifndef TIME_METER_HH
#define TIME_METER_HH

// prototype of the function
bool
getTime( long & sec, long & usec ) ; // return seconds and microseconds from January 1, 1970

void
timeDifference( long from_sec, long from_usec,
                long to_sec,   long to_usec,
                long & sec,    long & usec ) ;

static long from_sec, from_usec ;

inline
bool
timeStart() {
  return getTime( from_sec, from_usec ) ;
}

inline
double
timeStop() {
  long to_sec, to_usec, sec, usec;
  getTime( to_sec, to_usec ) ;
  timeDifference( from_sec, from_usec, to_sec, to_usec, sec, usec ) ;
  return sec+1E-6*usec ;
}

#endif
