/*

  Simple C-like dynamic vectors/matrices

  use doble, no typedef no template

*/

#include <cstddef>

// if C++ < C++11 define nullptr
#if __cplusplus <= 199711L
  #include <cstdlib>
  #ifndef nullptr
    #include <cstddef>
    #define nullptr NULL
  #endif
#endif

// define a vector as a struct with the size of the vector
// and a pointer to its values

struct Vec {
  int      size ;
  double * values ;
} ;

struct Mat {
  int       nrow, ncol ;
  double  * memory_block ; // allocated memory for the matrix
  double ** values ; // pointer to the rows of the matrix
} ;

void Initialize( struct Vec & vec ) ;
void Allocate( struct Vec & vec, int size ) ;
void Fill( struct Vec & mat, double val ) ;
void Free( struct Vec & vec ) ;

void Initialize( struct Mat & mat ) ;
void Allocate( struct Mat & mat, int nrow, int ncol ) ;
void AllocateAndInitializeRandom( struct Mat & mat, int nrow, int ncol ) ;
void Fill( struct Mat & mat, double val ) ;
void Free( struct Mat & mat ) ;

void
Mat_x_Vec( struct Mat const & mat, // ensure the compiler that mat is not modified inside...
           struct Vec const & vec,
           struct Vec       & res ) ;

void
Mat_x_Mat_123( struct Mat const & A, 
               struct Mat const & B,
               struct Mat       & C ) ;
void
Mat_x_Mat_132( struct Mat const & A, 
               struct Mat const & B,
               struct Mat       & C ) ;
void
Mat_x_Mat_213( struct Mat const & A, 
               struct Mat const & B,
               struct Mat       & C ) ;
void
Mat_x_Mat_231( struct Mat const & A, 
               struct Mat const & B,
               struct Mat       & C ) ;
void
Mat_x_Mat_312( struct Mat const & A, 
               struct Mat const & B,
               struct Mat       & C ) ;
void
Mat_x_Mat_321( struct Mat const & A, 
               struct Mat const & B,
               struct Mat       & C ) ;

void
Mat_x_Mat_with_tiling( struct Mat const & A, 
                       struct Mat const & B,
                       struct Mat       & C,
                       int tsize ) ;
